searchData={"items":[{"type":"extras","title":"MangoPi MQ Pro Support","doc":"# MangoPi MQ Pro Support\n\n[![CircleCI](https://circleci.com/gh/nerves-project/nerves_system_mangopi_mq_pro.svg?style=svg)](https://circleci.com/gh/nerves-project/nerves_system_mangopi_mq_pro)\n[![Hex version](https://img.shields.io/hexpm/v/nerves_system_mangopi_mq_pro.svg \"Hex version\")](https://hex.pm/packages/nerves_system_mangopi_mq_pro)\n\nThis is the base Nerves System configuration for the [MangoPi MQ Pro](#mangopi).\n\n*The MangoPi MQ Pro works well, but there are active updates upstream and here. Backwards incompatible changes may be out of our control.*\n\n![MangoPi MQ Pro](assets/images/mq-pro-pink-t.png)\n  [Image credit](#mangopi) \n\n| Feature              | Description                     |\n| -------------------- | ------------------------------- |\n| CPU                  | 1 GHz 64 bit RISC-V             |\n| Memory               | 512 MB or 1 GB DRAM             |\n| Storage              | MicroSD                         |\n| Linux kernel         | 6.1 w/ patches                  |\n| IEx terminal         | UART `ttyS0`                    |\n| GPIO, I2C, SPI       | Yes - [Elixir Circuits](https://github.com/elixir-circuits) |\n| Display              | Yes, but not supported yet      |\n| ADC                  | No                              |\n| PWM                  | 8 channels (4 exposed), but no Elixir support      |\n| UART                 | ttyS0                           |\n| Camera               | Yes, but not supported yet      |\n| Ethernet             | No                              |\n| WiFi                 | Onboard WiFi                    |\n| RTC                  | No                              |\n| HW Watchdog          | Yes                             |","ref":"readme.html"},{"type":"extras","title":"Using - MangoPi MQ Pro Support","doc":"The most common way of using this Nerves System is create a project with `mix\nnerves.new` and add `mangopi_mq_pro` references where needed and in a similar way\nto the default systems like `bbb`, etc. Then export `MIX_TARGET=mangopi_mq_pro`.\nSee the [Getting started\nguide](https://hexdocs.pm/nerves/getting-started.html#creating-a-new-nerves-app)\nfor more information.\n\nIf you need custom modifications to this system for your device, clone this\nrepository and update as described in [Making custom\nsystems](https://hexdocs.pm/nerves/customizing-systems.html).","ref":"readme.html#using"},{"type":"extras","title":"Example use - MangoPi MQ Pro Support","doc":"This example assumes some familiarity with Nerves. To use this system, you'll\nneed OTP 25. Follow the [Nerves installation\ninstructions](https://github.com/nerves-project/nerves/blob/main/docs/Installation.md)\nfor additional system dependencies.\n\nCreating a new hello world application:\n\n```sh\nmix nerves.new hello_mango\ncd hello_mango\n```\n\nOpen up your `mix.exs` and add `:mangopi_mq_pro` to the `@all_targets` list at\nthe top. It's ok to delete targets that you don't plan on using.\n\nThen add the `:nerves_system_mango_mq_pro` dependency to the `deps` function:\n\n```elixir\n    {:nerves_system_mangopi_mq_pro, \"~> 0.1\", runtime: false, targets: :mangopi_mq_pro},\n```\n\nThis will load the latest released version. To use the latest code on the `main`\nbranch here, add the following line:\n\n```elixir\n    {:nerves_system_mangopi_mq_pro, runtime: false, targets: :mangopi_mq_pro, nerves: [compile: true], git: \"https://github.com/nerves-project/nerves_system_mangopi_mq_pro\", branch: \"main\"}\n```\n\nTo build and write to a MicroSD card, run:\n\n```sh\nexport MIX_TARGET=mangopi_mq_pro\nmix deps.get\nmix firmware\nmix burn\n```","ref":"readme.html#example-use"},{"type":"extras","title":"Console access - MangoPi MQ Pro Support","doc":"The console is configured to output to the UART on pins 8 and 10 on the 40-pin\nGPIO connector. This is just like the Raspberry Pi. A 3.3V FTDI cable is needed\nto access the output.","ref":"readme.html#console-access"},{"type":"extras","title":"Networking - MangoPi MQ Pro Support","doc":"The board has two network interfaces, a WiFi module and a virtual Ethernet on\nthe USB C connector marked \"OTG\". If virtual Ethernet isn't working for you, try\na different USB cable. You're welcome.","ref":"readme.html#networking"},{"type":"extras","title":"GPIO - MangoPi MQ Pro Support","doc":"The following table is a mapping between the logical GPIO numbers used in\nsoftware (sysfs, Circuits.GPIO), and the pin numbers on the 20x2 Raspberry Pi\nheader. For example, to control pin 11 you would open a connection to GPIO 117.\n\n```elixir\n{:ok, pin} = Circuits.GPIO.open(117, :output)\n```\n\nThe comments in the \"Note\" columns come from the [official schematic](https://mangopi.org/_media/mq-pro-sch-v12.pdf#page=3).\n\n| GPIO | Note | Pin | Pin | Note | GPIO |\n| :--: | :--: | :-: | :-: | :--: | :--: |\n|      | 3v3  |  1  |  2  | Vin  |      |\n| 205  | SDA  |  3  | 4   | Vin  |      |\n| 204  | SCL  |  5  | 6   | GND  |      |\n| 39   | MCLK |  7  | 8   | TX0  | 40   |\n|      | GND  |  9  | 10  | RX0  | 41   |\n| 117  | TX1  | 11  | 12  | I2S_CLK / PWM0 / Audio | 37   |\n| 118  | RX1  | 13  | 14  | GND  |      |\n| 32   | PWM3 | 15  | 16  | PWM4 | 33   |\n|      | 3v3  | 17  | 18  | DC   | 110  |\n|      | MOSI | 19  | 20  | GND  |      |\n|      | MISO | 21  | 22  | RX2  | 65   |\n|      | SCLK | 23  | 24  | CS0  |      |\n|      | GND  | 25  | 26  | CS1  | 111  |\n| 145  | SDA  | 27  | 28  | SCL  | 144  |\n| 42   |      | 29  | 30  | GND  |      |\n| 43   |      | 31  | 32  | TX2  | 64   |\n| 44   |      | 33  | 34  | GND  |      |\n| 38   | PWM1 / I2S_FS | 35  | 36  | DI2  | 34   |\n| 113  |      | 37  | 38  | I2S_DI0  | 35   |\n|      | GND  | 39  | 40  | I2S_D0   | 36   |\n\nYou can also get the pinout at the IEx prompt by using the\n[pinout](https://hex.pm/packages/pinout) library.","ref":"readme.html#gpio"},{"type":"extras","title":"Pinout diagram - MangoPi MQ Pro Support","doc":"![© CC-0 4.0 Lucas Sifoni](/assets/MangoPI_MQ_PRO_Pinout.svg)","ref":"readme.html#pinout-diagram"},{"type":"extras","title":"Schematics and datasheets - MangoPi MQ Pro Support","doc":"* [Schematics](https://mangopi.cc/_media/mq-pro-sch-v12.pdf)\n* [IBOM](https://mangopi.cc/_media/mq-pro-v12-ibom.html) - Interactive web page\n  to help you find what part is located where\n* [D1 documentation](https://github.com/mangopi-sbc/MQ-Pro/tree/main/3.Docs)","ref":"readme.html#schematics-and-datasheets"},{"type":"extras","title":"Thanks - MangoPi MQ Pro Support","doc":"The most helpful Allwinner D1 information comes from\n[linux-sunxi.org/Allwinner_Nezha](https://linux-sunxi.org/Allwinner_Nezha). All\nof the work here wouldn't have been possible with out it. Thanks especially to\n[smaeul's Allwinner D1 Linux fork](https://github.com/smaeul/linux/tree/riscv/d1-wip/arch/riscv)\n\nHere are more useful links:\n\n* [bret.dk's ARMBian post](https://bret.dk/armbian-on-the-mangopi-mq-pro/)\n* [NixOS on D1](https://github.com/chuangzhu/nixos-sun20iw1p1)\n* [YuzukiHD Buildroot](https://github.com/YuzukiHD/Buildroot-YuzukiSBC)\n* [DongshanPI Store](https://www.aliexpress.com/item/3256803971669780.html)\n\n[Image credit](#mangopi): This image is from [mangopi.cc](https://mangopi.cc/mangopi_mqpro).","ref":"readme.html#thanks"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nThis project does NOT follow semantic versioning. The version increases as\nfollows:\n\n1. Major version updates are breaking updates to the build infrastructure.\n   These should be very rare.\n2. Minor version updates are made for every major Buildroot release. This\n   may also include Erlang/OTP and Linux kernel updates. These are made four\n   times a year shortly after the Buildroot releases.\n3. Patch version updates are made for Buildroot minor releases, Erlang/OTP\n   releases, and Linux kernel updates. They're also made to fix bugs and add\n   features to the build infrastructure.","ref":"changelog.html"},{"type":"extras","title":"v0.8.0 - Changelog","doc":"This is a major Buildroot update.\n\nPlease see the [nerves_system_br v1.26.0 release notes](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.26.0)\nfor upgrade instructions if you've forked this system.\n\n* New features\n  * Add device tree compiler to support compiling overlays at runtime\n\n* Updated dependencies\n  * [Erlang/OTP 26.2.2](https://erlang.org/download/OTP-26.2.2.README)\n  * [nerves_system_br v1.26.1](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.26.1)\n  * [Buildroot 2023.11.1](https://lore.kernel.org/buildroot/87cyu2k2gu.fsf@48ers.dk/T/)","ref":"changelog.html#v0-8-0"},{"type":"extras","title":"v0.7.1 - Changelog","doc":"This is a security/bug fix update.\n\n Package updates\n  * [Erlang/OTP 26.2.1](https://erlang.org/download/OTP-26.2.1.README)\n  * [nerves_heart 2.3.0](https://github.com/nerves-project/nerves_heart/releases/tag/v2.3.0)","ref":"changelog.html#v0-7-1"},{"type":"extras","title":"v0.7.0 - Changelog","doc":"This is a major Buildroot and toolchain update that also adds support for HDMI\noutput and runtime device tree overlays.\n\nPlease see [nerves_system_br v1.25.0 release notes](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.25.0)\nfor upgrade instructions if you've forked this system.\n\n* New features\n  * Fixed issues preventing the HDMI output from working and enabled libcairo to\n    support Scenic. Scenic works out of the box, but it appears that there are\n    still HDMI output issues for some monitors (1024x768 display instead of 1080p).\n  * Enabled runtime device tree overlay support. This is currently an expert\n    feature, but it does work for simple overlays.\n\n* Updated dependencies\n  * [nerves_system_br v1.25.2](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.25.2)\n  * [Buildroot 2023.08.4](https://lore.kernel.org/buildroot/87o7f6t7fs.fsf@48ers.dk/T/)\n  * [Erlang/OTP 26.1.2](https://erlang.org/download/OTP-26.1.2.README)","ref":"changelog.html#v0-7-0"},{"type":"extras","title":"v0.6.1 - Changelog","doc":"This is a security/bug fix update.\n\n* Package updates\n  * [nerves_system_br v1.24.1](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.24.1)\n  * [Erlang/OTP 26.1.1](https://erlang.org/download/OTP-26.1.1.README)\n  * [Buildroot 2023.05.3](https://lore.kernel.org/buildroot/87h6ngup34.fsf@48ers.dk/T/)","ref":"changelog.html#v0-6-1"},{"type":"extras","title":"v0.6.0 - Changelog","doc":"This is a Buildroot version update that appears to mostly contain bug and\nsecurity fixes. It should be a low risk upgrade from v1.23.2.\n\n* New features\n  * Support factory reset, preventing firmware reverts. See [Nerves.Runtime.FwupOps](https://hexdocs.pm/nerves_runtime/Nerves.Runtime.FwupOps.html)\n\n* Updated dependencies\n  * [nerves_system_br v1.24.0](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.24.0)\n  * [Buildroot 2023.05.2](https://lore.kernel.org/buildroot/87ledrkrpp.fsf@48ers.dk/T/), [2023.05.1](https://lore.kernel.org/buildroot/87351m8qm4.fsf@48ers.dk/T/), [2023.05](https://lore.kernel.org/buildroot/87r0qn2c77.fsf@48ers.dk/T/)\n  * [Erlang/OTP 26.1](https://erlang.org/download/OTP-26.1.README)","ref":"changelog.html#v0-6-0"},{"type":"extras","title":"v0.5.2 - Changelog","doc":"* Changes\n  * Add common USB to UART device drivers (Thanks to @Lucassifoni)\n\n* Updated dependencies\n  * [nerves_system_br v1.23.3](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.23.3)","ref":"changelog.html#v0-5-2"},{"type":"extras","title":"v0.5.1 - Changelog","doc":"This is a bug and security fix update. It should be a low risk upgrade.\n\n* Fixes\n  * Fix CTRL+R over ssh\n\n* Updated dependencies\n  * [nerves_system_br v1.23.2](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.23.2)\n  * [Buildroot 2023.02.2](https://lore.kernel.org/buildroot/87y1je6wva.fsf@48ers.dk/T/)","ref":"changelog.html#v0-5-1"},{"type":"extras","title":"v0.5.0 - Changelog","doc":"This is a major update that brings in Erlang/OTP 26 and Buildroot 2023.02.2.\n\n* New features\n  * CA certificates are included for OTP 26.\n\n* Updated dependencies\n  * [nerves_system_br v1.23.1](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.23.1)\n  * [Buildroot 2023.02.2](https://lore.kernel.org/buildroot/87wn03ifbl.fsf@48ers.dk/T/)\n  * [Erlang/OTP 26.0.2](https://erlang.org/download/OTP-26.0.2.README)","ref":"changelog.html#v0-5-0"},{"type":"extras","title":"v0.4.3 - Changelog","doc":"This is a bug and security fix update. It should be a low risk upgrade.\n\n* Updated dependencies\n  * [nerves_system_br v1.22.5](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.22.5)\n  * [Buildroot 2022.11.3](https://lore.kernel.org/buildroot/878rfuxbxx.fsf@dell.be.48ers.dk/T/)","ref":"changelog.html#v0-4-3"},{"type":"extras","title":"v0.4.2 - Changelog","doc":"This is a bug fix and Erlang version bump from 25.2 to 25.2.3. It should be a\nlow risk upgrade from v0.4.1.\n\n* Fixes\n  * Set Erlang crash dump timer to 5 seconds, so if an Erlang crash dump does\n    happen, it will run for at most 5 seconds. See erlinit.conf.\n\n* Updated dependencies\n  * [nerves_system_br v1.22.3](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.22.3)\n  * [Buildroot 2022.11.1](https://lore.kernel.org/buildroot/87ilh4dvax.fsf@dell.be.48ers.dk/T/#u)","ref":"changelog.html#v0-4-2"},{"type":"extras","title":"v0.4.1 - Changelog","doc":"* Changes\n  * Patch upstream device tree in v0.4.0 so that it supports the LEDs, SPI and\n    I2C0 without additional configuration.","ref":"changelog.html#v0-4-1"},{"type":"extras","title":"v0.4.0 - Changelog","doc":"** Not firmware upgradable from v0.3.2! **\n\nThis release pulls in upstream updates that remove bootloader workarounds, but\nrequired the U-Boot environment block to move. This means that it's not possible\nto firmware update from v0.3.2 to this one.\n\n* Changes\n  * Switch from Musl C to Glibc. This was done to increase compatibility -\n    specifically with RustlerPrecompiled which doesn't support Musl C on RISC-V.\n\n* Updated dependencies\n  * [nerves_system_br v1.22.1](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.22.1)\n  * Linux 6.1 with smael's Allwinner D1 updates\n  * GCC 12.2","ref":"changelog.html#v0-4-0"},{"type":"extras","title":"v0.3.2 - Changelog","doc":"* Changes\n  * Two Buildroot patch updates and an Erlang minor version update\n  * Nerves Heart v2.0 is now included. Nerves Heart connects the Erlang runtime\n    to a hardware watchdog. v2.0 has numerous updates to improve information\n    that you can get and also has more safeguards to avoid conditions that could\n    cause a device to hang forever.\n\n* Updated dependencies\n  * [nerves_system_br v1.21.6](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.21.6)\n  * [Erlang/OTP 25.2](https://erlang.org/download/OTP-25.2.README)\n  * [Buildroot 2022.08.3](https://lore.kernel.org/buildroot/87r0x7z5cw.fsf@dell.be.48ers.dk/T/#u)\n  * [nerves_heart v2.0.2](https://github.com/nerves-project/nerves_heart/releases/tag/v2.0.2)","ref":"changelog.html#v0-3-2"},{"type":"extras","title":"v0.3.1 - Changelog","doc":"* Changes\n  * Fix regression when building on x86_64 Linux where wrong toolchain was used.\n  * Reduce first-time Linux kernel download by using tarball source\n\n* Updated dependencies\n  * [nerves_system_br v1.21.2](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.21.2)\n  * [Erlang/OTP 25.1.2](https://erlang.org/download/OTP-25.1.2.README)","ref":"changelog.html#v0-3-1"},{"type":"extras","title":"v0.3.0 - Changelog","doc":"* Changes\n  * Support aarch64 Linux builds\n\n* Updated dependencies\n  * [nerves_system_br v1.21.1](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.21.1)\n    and also see [nerves_system_br v1.21.0](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.21.0)\n  * [Buildroot 2022.08.1](http://lists.busybox.net/pipermail/buildroot/2022-October/652816.html)\n  * [Erlang/OTP 25.1.1](https://erlang.org/download/OTP-25.1.1.README)","ref":"changelog.html#v0-3-0"},{"type":"extras","title":"v0.2.5 - Changelog","doc":"* Updated dependencies\n  * [nerves_system_br v1.20.6](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.20.6)\n  * [Erlang/OTP 25.0.4](https://erlang.org/download/OTP-25.0.4.README)\n  * [Buildroot 2022.05.2](http://lists.busybox.net/pipermail/buildroot/2022-August/650546.html)\n  * Also see [Buildroot 2022.05.1 changes](http://lists.busybox.net/pipermail/buildroot/2022-July/647814.html)","ref":"changelog.html#v0-2-5"},{"type":"extras","title":"v0.2.4 - Changelog","doc":"* Fixes\n  * Fix USB gadget mode on MacOS","ref":"changelog.html#v0-2-4"},{"type":"extras","title":"v0.2.3 - Changelog","doc":"This release synchronizes the device tree configuration with upstream's new\nMangoPi MQ Pro device tree. This has at least two noticable changes:\n\n1. The Blue LED is now called `\":status\"`. It was `\"blue:indicator\"` so any\n   references will need to be updated.\n2. The SPI device that's on the GPIO header pins is now `spidev0`. This makes it\n   the same as the Raspberry Pi, so this was a welcome change.\n\n* Updates\n  * Update Linux to smauel's wip-all branch. This is currently his latest and it\n    includes device tree updates specifically for the MangoPi MQ Pro.\n  * Serial numbers are now 8 hex digits since collisions were found with just 4.\n  * USB Gadget mode works on the OTG port (right-most port)\n  * Reverting firmware works now","ref":"changelog.html#v0-2-3"},{"type":"extras","title":"v0.2.2 - Changelog","doc":"* Updates\n  * Various deletions to the device tree to free up GPIOs that weren't used.\n  * Fix I2C0 pins\n\n* Updated dependencies\n  * [nerves_system_br v1.20.4](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.20.4)\n  * [Erlang/OTP 25.0.3](https://erlang.org/download/OTP-25.0.3.README)","ref":"changelog.html#v0-2-2"},{"type":"extras","title":"v0.2.1 - Changelog","doc":"This release has several updates, but mostly makes it possible to use SPI now.\n\n* Updates\n  * Linux 5.19-rc0 (smauel's wip-d1 Linux branch)\n  * SPI1 works now through the GPIO header\n  * Clean up DTB handling. The U-Boot device tree is the only one that's used so\n    all patching and building of the Linux one has been removed. Also U-Boot is\n    updated on firmware updates. This isn't good, but it's easier than reburning\n    the MicroSD card every time.","ref":"changelog.html#v0-2-1"},{"type":"extras","title":"v0.2.0 - Changelog","doc":"This release updates the Linux kernel to 5.18 in the hopes of fixing some Linux\nkernel flakiness.\n\nU-Boot has changed enough that I don't believe that a v0.1.1 image is\nupgradable. Please rewrite your MicroSD image.\n\n* Updates\n  * Linux 5.18-rc4 (smauel's wip-d1 Linux branch)\n  * Switch to the Nezha device tree since upstream updates have fixed the\n    warnings that caused me to create a custom dts.\n  * Enable earlycon for earlier logging from Linux","ref":"changelog.html#v0-2-0"},{"type":"extras","title":"v0.1.1 - Changelog","doc":"The release fixes some issues that made v0.1.0 hard to use. The flaky MMC boot\nissue is still present. If your board hits it, unplugging and replugging in the\nMicroSD card has been found to be a more reliable workaround than rebooting.\n\n* Updates\n  * Enable the RISC-V vector extension\n\n* Fixes\n  * Fix compilation warnings when using C standard headers. If a library had\n    `-Werror`, these would end up breaking Elixir libraries that had C/C++ code.\n  * Make sure that the watchdog is active during boot and can't be disabled.\n    This recovers (with a reboot) from some more hangs.","ref":"changelog.html#v0-1-1"},{"type":"extras","title":"v0.1.0 - Changelog","doc":"This is the initial release.","ref":"changelog.html#v0-1-0"}],"content_type":"text/markdown"}